unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Math, StdCtrls, Grids, Menus, ExtCtrls, Spin;

type
  TForm1 = class(TForm)
    ButtonCheckString: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    EditInitString: TEdit;
    EditV: TEdit;
    EditQ: TEdit;
    EditCheckingString: TEdit;
    EditQ0: TEdit;
    EditF: TEdit;
    EditV1: TEdit;
    ListBox1: TListBox;
    StringGrid1: TStringGrid;
    MainMenu1: TMainMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    N4: TMenuItem;
    N5: TMenuItem;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    GroupBoxTableDelta: TGroupBox;
    Button2: TButton;
    Button3: TButton;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    SpinEdit_kString: TSpinEdit;
    grpCheckString: TGroupBox;
    Image1: TImage;
    ScrollBox1: TScrollBox;
    procedure ButtonCheckStringClick(Sender: TObject);
    procedure N5Click(Sender: TObject);
    procedure N4Click(Sender: TObject);
    procedure N2Click(Sender: TObject);
    procedure N3Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure EditVKeyPress(Sender: TObject; var Key: Char);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormClear;
  private
    { Private declarations }
    procedure BuildGraph;
    procedure BuildTable;
    function Check: Boolean;
  public
    { Public declarations }
  end;

const
  R = 18;
  dx_norm = 60;
  QMax = 50; //   
  VMax = 20; //   

var
  Form1: TForm1;
  Q: TStringList; //    
  VT: TStringList;
  //V -   (   )
  delta: array[0..QMax, 0..VMax] of string; // 
  InitString: string; // 
  kString: Integer; //  
  // F  ( )  
  InFile: textFile;
  InName: string;
  ResMsg: string;

implementation

uses
  Unit3, Unit4;

{$R *.dfm}

procedure v_next(var v: string);
begin
  Delete(v, 1, 1);
  v := 'q' + IntToStr(StrToInt(v) + 1);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  VT := TStringList.Create;
  VT.Sorted := True;
  VT.Duplicates := dupIgnore;
  VT.CaseSensitive := True;

  Q := TStringList.Create;
  Q.Sorted := False;
  Q.Duplicates := dupAccept;
  Q.CaseSensitive := True;

  StringGrid1.Visible := False;
  ScrollBox1.Visible := False;
  ButtonCheckString.Enabled := False;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  VT.Free;
  Q.Free;
end;

procedure TForm1.FormClear;
var
  i, j: Integer;
begin
  EditQ0.Clear;
  EditV1.Clear;
  EditQ0.Clear;
  EditF.Clear;
  Form1.Image1.Canvas.Brush.Color := clSilver;
  Form1.Image1.Canvas.FillRect(Form1.Image1.Canvas.ClipRect);
  ButtonCheckString.Enabled := False;

  with StringGrid1 do
  begin
    for i := 1 to RowCount - 1 do
      Rows[i].Clear;
  end;

  //    
  for i := 0 to QMax do
    for j := 0 to VMax do
      delta[i, j] := '';

  Q.Clear;
end;

procedure TForm1.BuildTable;
var
  i, j, k: Integer;
  strVT: string;
  V: string;
begin
  FormClear;

  EditV1.Text := VT.CommaText;

  V := 'q0';
  Q.Append(V);

  for i := 1 to VT.Count do
  begin
    delta[0, i] := VT[i-1];
  end;

  for i := 1 to Length(InitString) do
  begin
    v_next(V);
    delta[Q.Count, VT.IndexOf(InitString[i]) + 1] := V;
    Q.Append(V);
  end;

  if (Length(InitString) mod kString) = 0 then
    k := 0
  else
    k := kString - (Length(InitString) mod kString);

  for i := 1 to k do
  begin
    v_next(V);
    for j := 1 to VT.Count do
      delta[Q.Count, j] := V;
    strVT := VT.CommaText;
    Q.Append(V);
  end;

  EditF.Text := V;

  for i := 1 to kString - 1 do
  begin
    v_next(V);
    for j := 1 to VT.Count do
      delta[Q.Count, j] := V;
    Q.Append(V);
  end;

  for j := 1 to VT.Count do
    delta[Q.Count, j] := EditF.Text;

  for j := 1 to Q.Count do
    delta[j, 0] := Q[j-1];

  with StringGrid1 do
  begin
    ColCount := VT.Count + 1;
    RowCount := Q.Count + 1;
    for i := 0 to RowCount - 1 do
      Rows[i].Clear;
    for i := 1 to VT.Count do
      Cells[i, 0] := VT[i - 1];
    for i := 1 to Q.Count do
    begin
      Cells[0, i] := Q[i - 1];
      for j := 1 to VT.Count do
        Cells[j, i] := delta[i, j];
    end;
  end;

  EditQ.Text := Q.CommaText;
  EditQ0.Text := Q[0];
  ButtonCheckString.Enabled := True;
end;

procedure TForm1.BuildGraph;
var
  i, j, k, x, x0, xF, {xL, } y: Integer;
  strVT: string;
  V: string;
  dx: Integer;

  procedure ArrowDown(x, y: Integer);
  begin
    Form1.Image1.Canvas.MoveTo(x, y);
    Form1.Image1.Canvas.LineTo(x - 3, y - 5);
    Form1.Image1.Canvas.MoveTo(x, y);
    Form1.Image1.Canvas.LineTo(x + 3, y - 5);
  end;

  procedure ArrowUp(x, y: Integer);
  begin
    Form1.Image1.Canvas.MoveTo(x, y);
    Form1.Image1.Canvas.LineTo(x - 3, y + 5);
    Form1.Image1.Canvas.MoveTo(x, y);
    Form1.Image1.Canvas.LineTo(x + 3, y + 5);
  end;

  procedure ArrowRight(x, y: Integer);
  begin
    Form1.Image1.Canvas.MoveTo(x, y);
    Form1.Image1.Canvas.LineTo(x - 5, y - 3);
    Form1.Image1.Canvas.MoveTo(x, y);
    Form1.Image1.Canvas.LineTo(x - 5, y + 3);
  end;

begin
  FormClear;

  EditV1.Text := VT.CommaText;

  for i := 1 to VT.Count do
  begin
    delta[0, i] := VT[i-1];
  end;

  V := 'q0';
  Q.Append(V);
  x := R + 15;
  x0 := x;
  y := 150;
  dx := dx_norm;

  Form1.Image1.Canvas.Font.Name := 'Tahoma';
  Form1.Image1.Canvas.Font.Size := 8;
  Form1.Image1.Canvas.Brush.Color := clLime;
  Form1.Image1.Canvas.Pen.Color := clBlack;
  Form1.Image1.Canvas.Ellipse(x - R, y - R, x + R, y + R);
  Form1.Image1.Canvas.TextOut(x - R div 2, y - R div 2, V);

  for i := 1 to Length(InitString) do
  begin
    v_next(V);
    delta[Q.Count, VT.IndexOf(InitString[i]) + 1] := V;
    Q.Append(V);
    Inc(x, dx);

    Form1.Image1.Canvas.Brush.Color := clLime;
    Form1.Image1.Canvas.Ellipse(x - R, y - R, x + R, y + R);
    Form1.Image1.Canvas.TextOut(x - R div 2, y - R div 2, V);
    Form1.Image1.Canvas.MoveTo(x0 + R, y);
    Form1.Image1.Canvas.LineTo(x - R, y);
    ArrowRight(x - R - 1, y);
    Form1.Image1.Canvas.Brush.Color := clSilver;
    Form1.Image1.Canvas.TextOut(((x + x0) div 2) - 5, y - 18, InitString[i]);
    Form1.Image1.Canvas.Brush.Color := clLime;

    x0 := x;
  end;

  if (Length(InitString) mod kString) = 0 then
    k := 0
  else
    k := kString - (Length(InitString) mod kString);

  if VT.Count * 10 + 2 * R > dx_norm then
    dx := VT.Count * 10 + 2 * R;

  for i := 1 to k do
  begin
    v_next(V);
    for j := 1 to VT.Count do
      delta[Q.Count, j] := V;
    strVT := VT.CommaText;
    Q.Append(V);
    Inc(x, dx);

    Form1.Image1.Canvas.Brush.Color := clLime;
    Form1.Image1.Canvas.Ellipse(x - R, y - R, x + R, y + R);
    Form1.Image1.Canvas.TextOut(x - R div 2, y - R div 2, V);
    Form1.Image1.Canvas.MoveTo(x0 + R, y);
    Form1.Image1.Canvas.LineTo(x - R, y);
    ArrowRight(x - R - 1, y);
    Form1.Image1.Canvas.Brush.Color := clSilver;
    Form1.Image1.Canvas.TextOut(((x + x0 - Form1.Image1.Canvas.TextWidth(strVT))
      div 2) - 0, y - 18 - 2, strVT);

    x0 := x;
  end;

  xF := x;

  Form1.Image1.Canvas.Brush.Color := clLime;
  Form1.Image1.Canvas.Ellipse(x - R + 2, y - R + 2, x + R - 2, y + R - 2);
  Form1.Image1.Canvas.TextOut(x - R div 2, y - R div 2, V);

  EditF.Text := V;

  for i := 1 to kString - 1 do
  begin
    v_next(V);
    for j := 1 to VT.Count do
      delta[Q.Count, j] := V;
    Q.Append(V);
    Inc(x, dx);

    Form1.Image1.Canvas.Brush.Color := clLime;
    Form1.Image1.Canvas.Ellipse(x - R, y - R, x + R, y + R);
    Form1.Image1.Canvas.TextOut(x - R div 2, y - R div 2, V);
    Form1.Image1.Canvas.MoveTo(x0 + R, y);
    Form1.Image1.Canvas.LineTo(x - R, y);
    ArrowRight(x - R - 1, y);
    Form1.Image1.Canvas.Brush.Color := clSilver;
    Form1.Image1.Canvas.TextOut(((x + x0 -
      Form1.Image1.Canvas.TextWidth(VT.CommaText))
      div 2) - 1, y - 18 - 2, VT.CommaText);

    x0 := x;
  end;

  for j := 1 to VT.Count do
    delta[Q.Count, j] := EditF.Text;

  Form1.Image1.Canvas.TextOut(((xF + x0 -
    Form1.Image1.Canvas.TextWidth(VT.CommaText)) div 2) - 5, y + R + 10,
    VT.CommaText);
  Form1.Image1.Canvas.MoveTo(x0 + 1, y + R);
  Form1.Image1.Canvas.LineTo(x0 + 1, y + R + 7);
  Form1.Image1.Canvas.LineTo(xF - 1, y + R + 7);
  Form1.Image1.Canvas.LineTo(xF - 1, y + R);

  ArrowUp(xF - 1, y + R);

  for j := 1 to Q.Count do
    delta[j, 0] := Q[j-1];

  EditQ.Text := Q.CommaText;
  EditQ0.Text := Q[0];
  ButtonCheckString.Enabled := True;
end;

procedure TForm1.ButtonCheckStringClick(Sender: TObject);
var
  i, j: Integer;
  CheckingString: string;
  R: Word;
begin
  ListBox1.Items.Clear;
  ResMsg := '';
  CheckingString := EditCheckingString.Text;

  i := Q.IndexOf(EditQ0.Text) + 1;
  while (CheckingString <> '') do
  begin
    ListBox1.Items.Add('(' + Q[i - 1] + ',' + CheckingString + ')');
    j := VT.IndexOf(CheckingString[1]) + 1;
    if j = 0 then
    begin
      ShowMessage('   : ' + CheckingString[1]);
      exit;
    end;
    if delta[i, j] = '' then
    begin
      ShowMessage('   ' + Q[i - 1] + '   ' +
        CheckingString[1]
        + '');
      exit;
    end;
    i := Q.IndexOf(delta[i, j]) + 1;
    Delete(CheckingString, 1, 1);
  end;

  ListBox1.Items.Add('(' + Q[i - 1] + ',#)');

  if Pos(Q[i - 1], EditF.Text) = 0 then
  begin
    ResMsg :=
      '    ,      .';
    R := Application.MessageBox(PChar(ResMsg + #13#10 + #13#10 +
      '   ?'),
      PChar(' '),
      MB_YESNO + MB_ICONINFORMATION);
  end
  else
  begin
    ResMsg := '  .';
    R := Application.MessageBox(PChar(ResMsg + #13#10 + #13#10 +
      '   ?'),
      PChar(' '),
      MB_YESNO + MB_ICONINFORMATION);
  end;
  if R = mrYes then
    N3Click(Sender);
end;

function TForm1.Check: Boolean;
var
  i: Integer;
begin
  InitString := EditInitString.Text;
  VT.CommaText := EditV.Text;
  kString := SpinEdit_kString.Value;

  if VT.Count = 0 then
  begin
    ShowMessage('   ');
    Result := False;
    exit;
  end;

  for i := 1 to Length(InitString) do
  begin
    if VT.IndexOf(InitString[i]) = -1 then
    begin
      ShowMessage('    : ' + InitString[i]);
      Result := False;
      exit;
    end;
  end;

  Result := True;
end;

procedure TForm1.N5Click(Sender: TObject);
begin
  AboutBox.ShowModal;
end;

procedure TForm1.N4Click(Sender: TObject);
begin
  Form3.ShowModal;
end;

function InFileIsOpen(fn: string): boolean;
var
  res: integer;
  answ: word;
begin
  if (strlen(PChar(fn)) > 0) then
  begin
    assignFile(InFile, fn);
{$I-}
    Reset(InFile);
{$I+}
    res := IOResult;
    if res <> 0 then
      repeat
        answ := MessageDlg('  '
          + fn + #13#10 + ' ?', mtWarning,
          [mbYes, mbNo], 0);
      until (res = 0) or (answ = mrNo);
    if res <> 0 then
      Result := False
    else
      Result := True;
  end
  else
  begin
    Application.MessageBox(
      '    !',
      '', MB_OK +
      MB_ICONWARNING);
    Result := False;
  end;
end;

procedure TForm1.N2Click(Sender: TObject);
var
  inStr: string;
  i: Integer;
  msg: string;
begin
  SetCurrentDir(GetCurrentDir);
  OpenDialog1.FileName := GetCurrentDir + '\' + ' .txt';
  OpenDialog1.Filter := ' |*.txt';
  OpenDialog1.Options := OpenDialog1.Options + [ofFileMustExist];
  if OpenDialog1.Execute then
    InName := OpenDialog1.FileName;
  if (InFileIsOpen(InName)) then
  begin
    FormClear;
    ReadLn(InFile);
    ReadLn(InFile, inStr);
    EditInitString.Text := inStr;
    ReadLn(InFile);
    ReadLn(InFile, inStr);
    EditV.Text := inStr;
    ReadLn(InFile);
    ReadLn(InFile, inStr);
    SpinEdit_kString.Value := StrToInt(inStr);
    ReadLn(InFile);
    ReadLn(InFile, inStr);
    EditCheckingString.Text := inStr;
    Closefile(InFile);
    EditQ.Text := '';
    EditV1.Text := '';
    EditQ0.Text := '';
    EditF.Text := '';
    ListBox1.Clear;
    for i := 0 to StringGrid1.RowCount - 1 do
      StringGrid1.Rows[i].Clear;
    msg := '    ' + #13#10 + OpenDialog1.FileName;
    Application.MessageBox(
      PChar(msg),
      '', MB_OK + MB_ICONINFORMATION);
  end;
end;

procedure TForm1.N3Click(Sender: TObject);
var
  OutFile: textFile;
  i, j: Integer;
  msg: string;
begin
  SetCurrentDir(GetCurrentDir);
  SaveDialog1.FileName := GetCurrentDir + '\' + ' .txt';
  SaveDialog1.Filter := ' |*.txt';
  SaveDialog1.Options := SaveDialog1.Options + [ofFileMustExist];
  if SaveDialog1.Execute then
  begin
    AssignFile(OutFile, SaveDialog1.FileName);
    Rewrite(OutFile);
    Writeln(OutFile, ' :');
    Writeln(OutFile, '');
    Writeln(OutFile, '  :');
    Writeln(OutFile, EditInitString.Text);
    Writeln(OutFile, ' :');
    Writeln(OutFile, EditV.Text);
    Writeln(OutFile, '  :');
    Writeln(OutFile, IntToStr(SpinEdit_kString.Value));
    Writeln(OutFile, '');
    Writeln(OutFile, '  :');
    Writeln(OutFile, '');
    Writeln(OutFile, ' :');
    Writeln(OutFile, EditQ.Text);
    Writeln(OutFile, ' :');
    Writeln(OutFile, EditV1.Text);
    Writeln(OutFile, ' :');
    Writeln(OutFile, EditQ0.Text);
    Writeln(OutFile, ' :');
    Writeln(OutFile, EditF.Text);
    Writeln(OutFile, ' :');

    for i := 0 to Q.Count do
    begin
      for j := 0 to VT.Count do
        if delta[i, j] <> '' then
          Write(OutFile, delta[i, j] + #9)
        else
          Write(OutFile, ' ' + #9);
      Writeln(OutFile, '');
    end;

    Writeln(OutFile, '');
    Writeln(OutFile, '    :');
    for i := 0 to ListBox1.Items.Count - 1 do
      Writeln(OutFile, ListBox1.Items[i]);
    Writeln(OutFile, '');
    Writeln(OutFile, ResMsg);
    Closefile(OutFile);
    msg := '   ' + #13#10 + SaveDialog1.FileName;
    Application.MessageBox(
      PChar(msg),
      '', MB_OK + MB_ICONINFORMATION);
  end;

end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  ScrollBox1.Visible := False;
  Form1.Image1.Visible := False;
  StringGrid1.Visible := True;
  if Check then
    BuildTable;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  ScrollBox1.Visible := True;
  Form1.Image1.Visible := True;
  StringGrid1.Visible := False;
  if Check then
    BuildGraph;
end;

procedure TForm1.EditVKeyPress(Sender: TObject; var Key: Char);
begin
  if (not (key = #8)) and (Length(EditV.Text) = VMax * 2 - 1) then
  begin
    key := #0;
    Application.MessageBox('    ',
      '', MB_OK + MB_ICONINFORMATION);
  end;
end;

end.

